﻿using System.Collections.Generic;

namespace Common.Classes
{
    /// <summary>
    /// Class containing fields for each Drop Rate that is shown in the Drop Rate Drop-Down Lists.
    /// </summary>
    public class DropRate
    {
        #region Properties

        /// <summary>
        /// Rate Value
        /// </summary>
        public int RateValue { get; set; } 

        /// <summary>
        /// Rate Description
        /// </summary>
        public string RateDescription { get; set; }

        #endregion

        #region Public Static Functions

        public static List<DropRate> LoadDropRateList()
        {
            List<DropRate> dropRates = new List<DropRate>();

            dropRates.Add(new DropRate { RateValue = 0, RateDescription = "Class 0 (1 in 256)" });
            dropRates.Add(new DropRate { RateValue = 1, RateDescription = "Class 1 (1 in 128)" });
            dropRates.Add(new DropRate { RateValue = 2, RateDescription = "Class 2 (1 in 64)" });
            dropRates.Add(new DropRate { RateValue = 3, RateDescription = "Class 3 (1 in 32)" });
            dropRates.Add(new DropRate { RateValue = 4, RateDescription = "Class 4 (1 in 16)" });
            dropRates.Add(new DropRate { RateValue = 5, RateDescription = "Class 5 (1 in 8)" });
            dropRates.Add(new DropRate { RateValue = 6, RateDescription = "Class 6 (1 in 4)" });
            dropRates.Add(new DropRate { RateValue = 7, RateDescription = "Class 7 (255 in 256 - 99.6%!)" });
            return dropRates;
        }
                
        #endregion
    }
}
